#define SystemSevenOrLater 1
#include "Types.r"

/* This resource is the standard "put" file DLOG, renamed to 256 */
resource 'DLOG' (256, purgeable)
	{
		{0, 0, 188, 344}, dBoxProc, invisible, noGoAway, 0,
		 256, "", noAutoCenter
	};

/*
 * This resource is the standard "put" file DITL, renamed to 256 with these changes:
 *  button 1 is changed in size, location, and title
 *  item 10 (prompt) is moved out of the dialog to be invisible
 *  item 11 (initial file name) is moved out of the dialog to be invisible
 * In addition, when I pass this DLOG/DITL to CustomPutFile(), I pass CustomPutFile()
 * an activation list which tells it that only item 7 (file/folder list) can have
 * keys activated against it.
 *
 * Things you would want to modify
 * Get rid of the New Folder button
 * Make the help item point to a non-system help resource
 */
resource 'DITL'(256)
	{	{
					/* changed this button's size and location */
					{152, 64, 172, 187}, Button { enabled, "Select this Folder" },
					{130, 252, 150, 332}, Button { enabled, "Cancel" },
					{0, 0, 0, 0}, HelpItem { disabled, HMScanhdlg {-6043}},
					{8, 235, 24, 337}, UserItem { enabled },
					{32, 252, 52, 332}, Button { enabled, "Eject" },
					{60, 252, 80, 332}, Button { enabled, "Desktop" },
					
					/* This is the only item I'll have in my activation list. */
					{29, 12, 127, 230}, UserItem { enabled },
					{6, 12, 25, 230}, UserItem { enabled },
					{119, 250, 120, 334}, Picture { disabled, 11 },

					/* moved offscreen to look more like a get dialog */
					{-157, -15, -173, -227}, EditText { enabled, "" },

					/* moved offscreen to look more like a get dialog */
					{-136, -15, -152, -227}, StaticText { disabled, "Get File Named:" },

					{88, 252, 108, 332}, UserItem { disabled },
	}	};


/* This resource is used to tell the result */
resource 'ALRT' (257) {
	{40, 40, 161, 365},
	257,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	},
	centerMainScreen
};

resource 'DITL' (257) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{90, 140, 110, 198},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{10, 30, 75, 302},
		StaticText {
			disabled,
			"Directory/Folder Name:  ^0\nOwner Name: ^1\nGroup Name: ^2"
		}
	}
};

/* StandardGetFile() DLOG */
resource 'DLOG' (-6042, purgeable)
	{
		{0, 0, 206, 344}, dBoxProc, invisible, noGoAway, 0,
		 -6042, "", noAutoCenter
	};



/* StandardGetFile() DITL */
resource 'DITL'(-6042)	{	{
					{135, 252, 155, 332}, Button { enabled, "Open" },
					{104, 252, 124, 332}, Button { enabled, "Cancel" },
					{0, 0, 0, 0}, HelpItem { disabled, HMScanhdlg {-6042}},
					{8, 235, 24, 337}, UserItem { enabled },
					{32, 252, 52, 332}, Button { enabled, "Eject" },
					{60, 252, 80, 332}, Button { enabled, "Desktop" },
					{29, 12, 159, 230}, UserItem { enabled },
					{6, 12, 25, 230}, UserItem { enabled },
					{91, 251, 92, 333}, Picture  { disabled, 11 },
					{164, 251, 184, 333}, Button {enabled, "Select"}
	}	};



